/* Algorithms.java  16 April 2003 */

import edu.neu.ccs.*;
import edu.neu.ccs.util.*;
import edu.neu.ccs.console.*;

import java.awt.*;
import java.math.*;
import java.util.*;

public class Algorithms implements ConsoleAware{

 
  // sort the list given by its Traversal, using the comp ordering
  public AList<City> insertionSort(Traversal<City> tr, Comparator<City> comp){
    try{
      if (!tr.isEmpty())
        return insert(tr.getFirst(), 
            insertionSort(tr.getRest(), comp), comp);
      else
        return new MTList<City>();
    }
    catch(IllegalUseOfTraversalException e){
      System.out.println(e.getMessage());
      return new MTList<City>();
    }  
  }

  // insert the given city into the given sorted list, order given by comp
  public AList<City> insert(City city, 
      AList<City> alist, 
      Comparator<City> comp){
    try{
      if (!alist.isEmpty()){
        if (comp.compare(city, alist.getFirst()) < 0){
          return new ConsList<City>(city, alist);
        }
        else{
          return new ConsList<City>((alist.getFirst()), 
              insert(city, ((ConsList<City>)alist).rest, comp));
        }
      }
      else
        return new ConsList<City>(city, alist);
    }
    catch(IllegalUseOfTraversalException e){
      System.out.println(e.getMessage());
      return new MTList<City>();
    }  
  }

}

